;; -*- lisp -*-
;;
;; This system is used for defining the cl-interpol syntax
;;

(eval-when (:compile-toplevel :load-toplevel :execute)
  (unless (find-package :cl-interpol-syntax)
    (defpackage :cl-interpol-syntax
	(:use :common-lisp :asdf))))

(in-package :cl-interpol-syntax)

(defsystem :cl-interpol-syntax
  :description "A cl-syntax-sugar:defsyntax"
  :author "Acceleration.net"
  :licence "BSD like (so what you want)"
  :depends-on (:cl-interpol :slim-cl-syntax-sugar))

(defmethod asdf::traverse ( (op asdf:operation) (s (eql (find-system :cl-interpol-syntax))))
  ;; ensure that operations on the system get performed on the system
  (let ((results (call-next-method)))
    (if (find s results :key #'cdr)
	results
	(append results (list (cons op s))))))

(defmethod asdf:perform ( (op asdf:operation) (system (eql (find-system :cl-interpol-syntax))))
  (when (next-method-p) (call-next-method))
  (let ((*package* (find-package :cl-interpol-syntax)))
    (cl-syntax-sugar:define-syntax cl-interpol (&optional (dispatch-char #\#) (sub-char #\?))
      "define the interpol syntax"
      (set-dispatch-macro-character dispatch-char sub-char #'cl-interpol::interpol-reader))))
