;; -*- lisp -*-
;;
;; This system is used for defining the clsql syntax
;;
(eval-when (:compile-toplevel :load-toplevel :execute)
  (unless (find-package :clsql-syntax)
    (defpackage :clsql-syntax
	(:use :common-lisp :asdf))))

(in-package :clsql-syntax)

(defsystem :clsql-syntax
  :description "A cl-syntax-sugar:defsyntax"
  :author "Acceleration.net"
  :licence "BSD like (so what you want)"
  :depends-on (:clsql :slim-cl-syntax-sugar))

(defmethod asdf::traverse ( (op asdf:operation) (s (eql (find-system :clsql-syntax))))
  ;; ensure that operations on the system get performed on the system
  (let ((results (call-next-method)))
    (if (find s results :key #'cdr)
	results
	(append results (list (cons op s)))
	)))

(defmethod asdf:perform ( (op asdf:operation) (system (eql (find-system :clsql-syntax))))
  (when (next-method-p) (call-next-method))
  (let ((*package* (find-package :clsql-syntax)))
    (cl-syntax-sugar:define-syntax clsql ()
      "define the interpol syntax"
      (set-macro-character clsql-sys::*sql-macro-open-char* #'clsql-sys::sql-reader-open)
      (set-macro-character clsql-sys::*sql-macro-close-char* (get-macro-character #\))))))
